***   f77 defenitions for MPI operators, datatypes, character types, 
***       communicators, and return codes

      INTEGER MPI_SUCCESS, MPI_UNDEFINED

      INTEGER MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION 
      INTEGER MPI_COMPLEX, MPI_DOUBLE_COMPLEX,MPI_LOGICAL
      INTEGER MPI_CHARACTER, MPI_BYTE, MPI_2INTEGER, MPI_2REAL
      INTEGER MPI_2DOUBLE_PRECISION, MPI_2COMPLEX, MPI_2DOUBLE_COMPLEX
      INTEGER MPI_INTEGER1, MPI_INTEGER2, MPI_INTEGER4
      INTEGER MPI_REAL4, MPI_REAL8, MPI_UB, MPI_LB
      INTEGER MPI_PACKED
      INTEGER MPI_CHAR,MPI_UNSIGNED_CHAR,MPI_SHORT,MPI_UNSIGNED_SHORT
      INTEGER MPI_INT,MPI_UNSIGNED,MPI_LONG,MPI_UNSIGNED_LONG
      INTEGER MPI_FLOAT,MPI_DOUBLE,MPI_LONG_DOUBLE,MPI_LONG_LONG_INT

      INTEGER MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND
      INTEGER MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR, MPI_MINLOC
      INTEGER MPI_MAXLOC

      INTEGER MPI_COMM_WORLD, MPI_COMM_SELF

      INTEGER MPI_ANY_SOURCE, MPI_ANY_TAG


*** Return code

      PARAMETER (MPI_SUCCESS=0, MPI_UNDEFINED=-1)

*** Datatype defenitions (first 16 are for C compatibility)

      PARAMETER (MPI_CHAR             = 1)
      PARAMETER (MPI_UNSIGNED_CHAR    = 2)
*     PARAMETER (MPI_BYTE             = 3)
      PARAMETER (MPI_SHORT            = 4)
      PARAMETER (MPI_UNSIGNED_SHORT   = 5)
      PARAMETER (MPI_INT              = 6)
      PARAMETER (MPI_UNSIGNED         = 7)
      PARAMETER (MPI_LONG             = 8)
      PARAMETER (MPI_UNSIGNED_LONG    = 9)
      PARAMETER (MPI_FLOAT            =10)
      PARAMETER (MPI_DOUBLE           =11)
      PARAMETER (MPI_LONG_DOUBLE      =12)
      PARAMETER (MPI_LONG_LONG_INT    =13)
*     PARAMETER (MPI_PACKED           =14)

      PARAMETER (MPI_COMPLEX          =23)
      PARAMETER (MPI_DOUBLE_COMPLEX   =24)
      PARAMETER (MPI_LOGICAL          =25)
      PARAMETER (MPI_REAL             =26)
      PARAMETER (MPI_DOUBLE_PRECISION =27)
      PARAMETER (MPI_INTEGER          =28)
      PARAMETER (MPI_2INTEGER         =29)
      PARAMETER (MPI_2COMPLEX         =30)
      PARAMETER (MPI_2DOUBLE_COMPLEX  =31)
      PARAMETER (MPI_2REAL            =32)
      PARAMETER (MPI_2DOUBLE_PRECISION=33)

      PARAMETER (MPI_CHARACTER        =1)
      PARAMETER (MPI_BYTE             =3)
      PARAMETER (MPI_PACKED           =14)

      PARAMETER (MPI_REAL4            =40)
      PARAMETER (MPI_REAL8            =41)
      PARAMETER (MPI_INTEGER1         =42)
      PARAMETER (MPI_INTEGER2         =43)
      PARAMETER (MPI_INTEGER4         =44)


*** Operator type definitions

      PARAMETER (MPI_MAX   =100)
      PARAMETER (MPI_MIN   =101)
      PARAMETER (MPI_SUM   =102)
      PARAMETER (MPI_PROD  =103)
      PARAMETER (MPI_LAND  =104)
      PARAMETER (MPI_BAND  =105)
      PARAMETER (MPI_LOR   =106)
      PARAMETER (MPI_BOR   =107)
      PARAMETER (MPI_LXOR  =108)
      PARAMETER (MPI_BXOR  =109)
      PARAMETER (MPI_MINLOC=110)
      PARAMETER (MPI_MAXLOC=111)

*** Communicator type definitions

      PARAMETER (MPI_COMM_WORLD=0)
c     PARAMETER (MPI_COMM_SELF =1)

*** Special source and tag definitions

      PARAMETER (MPI_ANY_SOURCE = (-1))
      PARAMETER (MPI_ANY_TAG = (-1))

*** Timing function setup

      DOUBLE PRECISION MPI_WTIME, MPI_WTICK
      EXTERNAL MPI_WTIME, MPI_WTICK

*** Status setup

      INTEGER MPI_STATUS_SIZE
      INTEGER MPI_SOURCE, MPI_TAG, MPI_ERROR
      PARAMETER (MPI_STATUS_SIZE=4)

      PARAMETER (MPI_SOURCE=2, MPI_TAG=3, MPI_ERROR=4)

